<%

                     ' *********************** simple product catalog ************************

                     ' DateCreated:      1/4/2000
                     ' DateLastModified: 1/4/2000

                     '  NOTES:            
                     '  This application does not require any of the include files
                     '  that are colored green below. These include files are used
                     '  to create the ASP Emporium website layout. To use this code
                     '  as is, delete all includes below.

                     '  BE SURE TO CHECK OUT THE 2ND INSTALLMENT OF THIS EXAMPLE,
                     '  THE SHOPPING CART WHICH IS AN INTEGRAL PART OF THIS PRODUCT
                     '  CATALOG SYSTEM.

                     '  This application requires the myData.mdb database and uses 
                     '  the productCatalog table.

                     ' the table named productCatalog consists of the following fields:

                     ' adminID - autonumber
                     ' categoryFull - the main category of the item
                     '   each item is separated into categories and each category 
                     '   has it's own sub categories.
                     ' subCategory - the sub category of the item
                     ' itemName - the name of the item
                     ' itemPrice - the price of the item in US Dollars
                     ' itemDesc - a description of the item
                     ' itemMisc - miscellaneous info about the product.
                     ' itemPicture - the path to the item's picture

                     ' you definitely need to add error handling to this app.
                     ' It currently has none.

                    Dim SQL1, productCatalogOptions, viewCategory, displayField
                    Dim storeNavBar, SQL2, viewSubCategory

                    viewCategory = request("cat")
                    viewSubCategory = request("sCat")

                    Conn.Open(Application("dbConn"))
                     ' make sure the recordset and connection closes in the event of an error by
                     ' calling the on error resume next command. This should save us in the event that
                     ' someone types an incorrect query string into the address bar. If the recordset doesn't close,
                     ' you get an error because the recordset remains open the next time the page is viewed.
                     ' If this happens, you must restart the computer and then delete the myData.ldb file
                     ' which is in the same directory as the database you were accessing with ASP.
                    On Error Resume Next
                    if viewSubCategory = "" then
                       ' there is no sub category query string so we are not displaying individual items
                      if viewCategory = "" then
                         ' there is no category query string so let's display all the main categories
                         ' displayField is the database field we will count and group below.
                        displayField = "categoryFull"  '
                        SQL2 = ""
                      else
                         ' we need to display the subCategories of the chosen category.
                        displayField = "subCategory"
                        SQL2 = "WHERE categoryFull LIKE '" & viewCategory & "' "
                      end if
                       ' assemble the SQL statement.
                      SQL1 = "SELECT " & displayField & ", COUNT(" & displayField & ") AS majorCategories "
                      SQL1 = SQL1 + "FROM productCatalog "
                      SQL1 = SQL1 + SQL2
                      SQL1 = SQL1 + "GROUP BY " & displayField & ";"
                      Rs.Open SQL1, Conn
                      Do While NOT Rs.BOF AND NOT Rs.EOF
                         ' display the categories or sub categories depending 
                         ' on the amount of query strings. The categories or sub categories
                         ' displayed will be clickable links.
                        if viewCategory = "" then
                          productCatalogOptions = productCatalogOptions & "<a href=""productCatalog.asp?cat=" & server.URLEncode(Rs(displayField)) & """><big>"
                          productCatalogOptions = productCatalogOptions & Rs(displayField) & "</big></a><br>" & vbCrLf
                        else
                          productCatalogOptions = productCatalogOptions & "<a href=""productCatalog.asp?cat=" & server.URLEncode(viewCategory) & "&sCat=" & server.URLEncode(Rs(displayField)) & """><big>"
                          productCatalogOptions = productCatalogOptions & Rs(displayField) & "</big></a><br>" & vbCrLf
                        end if
                        Rs.Movenext
                      LOOP
                    else
                       ' we are displaying individual items based on the 
                       ' category and sub category chosen by the client when they
                       ' click the catalog links.
                      SQL1 = "SELECT * FROM productCatalog WHERE categoryFull LIKE '" & viewCategory & "' "
                      SQL1 = SQL1 & "AND subCategory LIKE '" & viewSubCategory & "' ORDER BY itemName;"
                      Rs.Open SQL1, Conn
                      Do While NOT Rs.BOF AND NOT Rs.EOF
                         ' display the items in that sub category.
                        productCatalogOptions = productCatalogOptions & "<strong>" & Rs("itemName") & "</strong><br>"
                        productCatalogOptions = productCatalogOptions & Rs("itemDesc") & "<br>" & "<i>" & FormatCurrency(Rs("itemPrice"), 2) & "</i><br>"
                        productCatalogOptions = productCatalogOptions & Rs("itemMisc") & "<br>"
                         ' don't forget the add to cart button. What good is a product catalog
                         ' if you can't select items to purchase?
                        productCatalogOptions = productCatalogOptions & "<a href=""shoppingCart.asp?action=add&iNum=" & Rs("adminID") & """>"
                        productCatalogOptions = productCatalogOptions & "<font size=-1 face=arial>add to cart</font></a><br><br>"
                        Rs.Movenext
                      LOOP
                    end if
                     ' now lets create a quick navigation bar for our catalog.
                    storeNavBar = ""
                    if viewCategory = "" AND viewSubCategory ="" then
                       ' we are at home
                      storeNavBar = "home"
                    else
                       ' we aren't at home so display the link to the main categories.
                      storeNavBar = "<a href=""productCatalog.asp"">home</a>&nbsp;&gt;&nbsp;"
                      if viewCategory <> "" then
                         ' if there is a category to view then...
                        if viewSubCategory <> "" then
                           ' display the sub category and a link to the category
                          storeNavBar = storeNavBar & "<a href=""productCatalog.asp?cat=" & server.URLEncode(viewCategory) & """>"
                          storeNavBar = storeNavBar & viewCategory & "</a>&nbsp;&gt;&nbsp;" & viewSubCategory
                        else
                           ' display the category only
                          storeNavBar = storeNavBar & viewCategory
                        end if
                      end if
                    end if
                    if err <> 0 then
                      productCatalogOptions = productCatalogOptions & "A database error has occurred. Please try again later."
                    end if
                     ' close recordset and connection
                    Rs.Close
                    Conn.Close
                    %>


                   


                    <html>
                     <head>
                      <title>The ASP Emporium - Interactive Product Catalog Example</title>
                      <style type="text/css">
                       h3 {color: #CC3300;}
                      </style>
                     </head> 
                     <body background="/aspEmporium/bg.gif" bgcolor="#EEEEEE">
                    
                      <table width=100% cellpadding=2 cellspacing=0 border=0>
                       <tr>
                        <td valign=top></td>
                        <td valign=top>
                        <font face="arial, verdana, helvetiva, times new roman">
                        <h3>Product Catalog</h3>
                        The product catalog displays items from a database based 
                        on categories and sub categories selected by the client.
                        The second half of this example is the shopping cart application.
                        Using both together creates a very simple ecommerce system that
                        allows viewers to select items for purchase from this product catalog.
                        <br>
                        <br>
                        <table width=100%>
                         <tr>
                          <td>
                          Store Navigation: <%=storeNavBar%>
                          </td>
                          <td valign=right>
                          <a href="shoppingCart.asp">View Shopping Cart</a>
                          </td>
                         </tr>
                        </table>
                        <br>
                        <br>
                    <%=productCatalogOptions%>
                        <br>
                        <br>
                        
                        <br>
                        <br>
                        <center><a href="shoppingCart.asp">step 2: The shopping cart</a></center>
                        </font>
                        </td>
                       </tr>
                      </table>
                     </body>
                    </html>